#include <stdio.h>
#include <stdlib.h>

char chunks[10];
char *chunks_data = "ftzirR";
int num = 0;
char buf[10];

// generate all tests for sequence length 'len'
void gen(int len, int pos) {
   if(len == 0) {
      buf[pos] = 0;
      if((num % 100) == 0) printf("echo_n '.'\n");
      printf("cat ");
      for(const char *p = buf; *p; p++)
	printf("chunks/%c ", *p);
      printf("> %d_%s.mp3\n", strlen(buf), buf);
      num++;
   } else {     
      for(char *p = chunks; *p; p++) {	 
	 char c = *p;
	 if(c != '_') {
	    *p = '_';
	    buf[pos] = c;
	    gen(len - 1, pos + 1);
	    *p = c;
	 }
      }
   }
}


int main(int ac, char *av[]) {
   if(ac != 2) {
      fprintf(stderr, "Usage: gentest <max_seq_len>\n");
      exit(1);
   }
   strcpy(chunks, chunks_data);

   printf("#!/bin/sh\n");
   // generate all tests for sequences length 1..5
   for(int len = 1; len <= atoi(av[1]); len++) {
      // generate all tests for sequence length 'len'
      gen(len, 0);
   }
   printf("echo\n");
   fprintf(stderr, "generating %d tests ", num);
   return 0;
}

